transform_units_temperature <- function(data, original_units, new_units,
                                        var_name, var_index = 1,
                                        var_dim = "var") {

  # Method 1: use asplit
  data_arr <- data[[1]]$data
  data_list <- asplit(data_arr, which(names(dim(data_arr)) == var_dim))
  if (original_units == 'c' & new_units == 'k') {
    data_list[[var_index]] <- data_list[[var_index]] + 273.15
    data[[1]]$attrs$Variable$metadata[[var_name]]$units <- "K"
  }
  if (original_units == 'k' & new_units == 'c') {
    data_list[[var_index]] <- data_list[[var_index]] - 273.15
    data[[1]]$attrs$Variable$metadata[[var_name]]$units <- "C"
  }

  # Combine list back to array
  data_arr <- array(unlist(data_list),
                    dim = c(dim(data_list[[1]]), var = length(data_list)))
  data[[1]]$data <- aperm(data_arr, match(names(dim(data[[1]]$data)), 
                          names(dim(data_arr))))

  return(data)
}

  # Method 2: use Apply
  if (original_units == 'c' & new_units == 'k') {

    data[[1]]$data <- multiApply::Apply(data[[1]]$data,
                                        target_dims = var_dim, output_dims = var_dim,
                                        fun = .transform_units_temp,
                                        type = "c_to_k", var_index = var_index)$output1
    data[[1]]$attrs$Variable$metadata[[var_name]]$units <- "K"

  }
  if (original_units == 'k' & new_units == 'c') {
    data[[1]]$data <- multiApply::Apply(data[[1]]$data,
                                        target_dims = var_dim, output_dims = var_dim,
                                        fun = .transform_units_temp,
                                        type = "k_to_c", var_index = var_index)$output1
    data[[1]]$attrs$Variable$metadata[[var_name]]$units <- "C"

  }

 .transform_units_temp <- function(data, type, var_index) {
   # data: 'var'
   if (type == "k_to_c") {
    data[var_index] <- data[var_index] - 273.15
   } else if (type == "c_to_k") {
     data[var_index] <- data[var_index] + 273.15
   }
   return(data)
 }

